.586
OPTION CASEMAP:NONE
.CODE
;--------------------------------------------------------------------------------
InitDataBase		PROC	uses ebx edi
	
	mov		edi,		pGPBuffer
	mov		edx,		pCommLine
	xor		ecx,		ecx
	cmp		byte ptr [edx], 22h
	jne		@F
		add		edx,		1
	@@:
	
	LoopCopyPath:
	mov		al,		byte ptr [edx+ecx]
	cmp		al,		"\"
	jne		@F
		mov		ebx,		ecx
	@@:
	mov		byte ptr [edi+ecx], al
	add		ecx,	1
	cmp		al,		22h ; "
	jne		LoopCopyPath
	
	;MyDBF.DBF,0
	mov		dword ptr [edi+ebx+1],"BDyM"
	mov		dword ptr [edi+ebx+5],"BD.F"
	mov		word ptr [edi+ebx+9],0046h
	
	INVOKE	CreateFile,	pGPBuffer,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL
	.IF		eax==INVALID_HANDLE_VALUE
		INVOKE	CreateNewDataBase
		ret
	.ENDIF
	mov		DBFMemory.hFileDBF,	eax
	INVOKE	LoadDataBase
	ret
InitDataBase		ENDP
;--------------------------------------------------------------------------------
CloseDataBase		PROC	uses edi ebx esi
LOCAL	hTmpFile	:DWORD
LOCAL	Answer		:DWORD
LOCAL	pNewTable	:DWORD
	
	
	mov		pNewTable,	0
	mov		edi,		pGPBuffer
	mov		edx,		pCommLine
	xor		ecx,		ecx
	cmp		byte ptr [edx], 22h
	jne		@F
		add		edx,		1
	@@:
	;copy the path of exe in buffer
	LoopCopyPath:
	mov		al,		byte ptr [edx+ecx]
	cmp		al,		"\"
	jne		@F
		mov		ebx,		ecx
	@@:
	mov		byte ptr [edi+ecx], al
	add		ecx,	1
	cmp		al,		22h ; "
	jne		LoopCopyPath
	mov		dword ptr [edi+ebx],0
	INVOKE	SetCurrentDirectory,edi
	mov		byte ptr [edi+ebx],"\"
	
	;add to this path "MyDBF.TMP",0
	mov		dword ptr [edi+ebx+1],"BDyM"
	mov		dword ptr [edi+ebx+5],"MT.F"
	mov		word ptr [edi+ebx+9],0050h
	
	;open or create this file
	INVOKE	CreateFile,	pGPBuffer,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,0,NULL
	mov		hTmpFile,	eax
	cmp		eax,		INVALID_HANDLE_VALUE
	je		GetOutErr
	
	;store in buffer the header
	mov		eax,		DBFMemory.NrOfEntrys
	mov		(HeaderDBF ptr [edi]).Signature,DBF_Magic
	mov		(HeaderDBF ptr [edi]).NrOfEntrys, eax
	
	; ...
	
	;write the header to file
	INVOKE	WriteFile,	hTmpFile,pGPBuffer,SIZEOF HeaderDBF,ADDR Answer,NULL
	
	;make room for table
	mov		eax,		DBFMemory.NrOfEntrys
	cmp		eax,		0
	je		ContentReady
	shl		eax,		3
	push	eax
	add		eax,		SIZEOF HeaderDBF
	INVOKE	SetFilePointer,hTmpFile,eax,NULL,FILE_BEGIN
	INVOKE	SetEndOfFile,hTmpFile
	
	push	dword ptr NULL
	push	hHeap
	call	HeapAlloc
	test	eax,		eax
	jz		GetOutErr
	mov		pNewTable,	eax
	
	mov		esi,		DBFMemory.pTable
	mov		edi,		pNewTable
	
	xor		ebx,		ebx
	.WHILE	ebx<DBFMemory.NrOfEntrys
		INVOKE	SetFilePointer,DBFMemory.hFileDBF,dword ptr [esi+ebx*8],NULL,FILE_BEGIN
		mov		eax,	dword ptr [esi+ebx*8+4]
		cmp		eax,	dimGPBuffer
		mov		dword ptr [edi+ebx+4],eax
		jbe		@F
			add		eax,			100h
			INVOKE	HeapReAlloc,	hHeap,0,pGPBuffer,eax
			test	eax,			eax
			jz		GetOutErr
			mov		pGPBuffer,		eax
			INVOKE	HeapSize,		hHeap,0,eax
			mov		dimGPBuffer,	eax
		@@:
		INVOKE	ReadFile,	DBFMemory.hFileDBF,pGPBuffer,dword ptr [esi+ebx*8+8],ADDR Answer,NULL
		INVOKE	SetFilePointer,	hTmpFile,0,0,FILE_CURRENT
		mov		dword ptr [edi+ebx],	eax
		INVOKE	WriteFile,	hTmpFile,pGPBuffer,dword ptr [esi+ebx*8+8],ADDR Answer,NULL
		add		ebx,		1
	.ENDW
	
	INVOKE	SetFilePointer,	hTmpFile,SIZEOF HeaderDBF,NULL,FILE_BEGIN
	mov		ecx,			DBFMemory.NrOfEntrys
	shl		ecx,			3
	INVOKE	WriteFile,		hTmpFile,pNewTable,ecx,ADDR Answer,NULL
	ContentReady:
	
	
	INVOKE	CloseHandle,	hTmpFile
	INVOKE	CloseHandle,	DBFMemory.hFileDBF
	mov		edi,			pGPBuffer
	mov		esi,			edi
	add		esi,			20h
	mov		dword ptr [edi],  "BDyM"
	mov		dword ptr [edi+4],"MT.F"
	mov		 word ptr [edi+8],0050h;   MyDBF.TMP

	mov		dword ptr [esi],  "BDyM"
	mov		dword ptr [esi+4],"BD.F"
	mov		 word ptr [esi+8],0046h;   MyDBF.DBF
	
	INVOKE	DeleteFile,		esi
	INVOKE	MoveFile,		edi,esi
	
GetOut_OK:
mov		eax,	1
ret
GetOutErr:
xor		eax,	eax
ret
CloseDataBase 		ENDP
;--------------------------------------------------------------------------------
CreateNewDataBase	PROC
;assumes that in pGPBuffer is tha path and name of the file to create
;edi points to pGPBuffer
LOCAL	Answer		:DWORD

	INVOKE	CreateFile,	pGPBuffer,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL
	cmp		eax,		INVALID_HANDLE_VALUE
	je		GetOutErr
	mov		DBFMemory.hFileDBF,	eax
	
	mov		(HeaderDBF ptr [edi]).Signature, DBF_Magic
	mov		(HeaderDBF ptr [edi]).NrOfEntrys, 0
	mov		DBFMemory.NrOfEntrys, 0
	
	; ...
	
	INVOKE	WriteFile,	DBFMemory.hFileDBF,pGPBuffer,SIZEOF HeaderDBF,ADDR Answer,NULL
	
	INVOKE	HeapAlloc,	hHeap,0,100h
	mov		DBFMemory.pTable, eax
	test	eax,		eax
	jz		GetOutErr
	INVOKE	HeapSize,	hHeap,0,eax
	mov		DBFMemory.dimTable, eax
	
	
	
GetOut_OK:
mov		eax,	1
ret
GetOutErr:
xor		eax,	eax
ret
CreateNewDataBase 	ENDP
;--------------------------------------------------------------------------------
LoadDataBase		PROC
;edi points to pGPBuffer
LOCAL	Answer		:DWORD

	;read the header
	INVOKE	ReadFile,	DBFMemory.hFileDBF,pGPBuffer,SIZEOF HeaderDBF,ADDR Answer,NULL
	;get out if invalid
	cmp		(HeaderDBF ptr [edi]).Signature, DBF_Magic
	jne		GetOutErr
	;allocate memory for table
	mov		eax,		(HeaderDBF ptr [edi]).NrOfEntrys
	mov		DBFMemory.NrOfEntrys, eax
	shl		eax,		3
	add		eax,		100h
	INVOKE	HeapAlloc,	hHeap,0,eax
	mov		DBFMemory.pTable, eax
	test	eax,		eax
	jz		GetOutErr
	INVOKE	HeapSize,	hHeap,0,eax
	mov		DBFMemory.dimTable, eax
	;read the table
	mov		ecx,		DBFMemory.NrOfEntrys
	shl		ecx,		3
	INVOKE	ReadFile,	DBFMemory.hFileDBF,DBFMemory.pTable,ecx,ADDR Answer,NULL
	
GetOut_OK:
mov		eax,	1
ret
GetOutErr:
xor		eax,	eax
ret
LoadDataBase 		ENDP
;--------------------------------------------------------------------------------
AddDBFEntry			PROC	uses esi ebx pAddEntryStr:DWORD
LOCAL	pEntry		:DWORD
LOCAL	Error		:DWORD
LOCAL	Answer		:DWORD


	mov		Error,		0
	mov		pEntry,		0
	mov		esi,		pAddEntryStr
	;compute lenght for text not counted
	
	cmp		(AddEntryStr ptr [esi]).dimName, -1
	jne		DimTextReady
		xor		ecx,		ecx
		mov		edx,		(AddEntryStr ptr [esi]).pName
		.WHILE	byte ptr [edx+ecx]!=0
			add		ecx,		1
		.ENDW
		mov		(AddEntryStr ptr [esi]).dimName,ecx
	DimTextReady:
	
	cmp		(AddEntryStr ptr [esi]).dimDescr, -1
	jne		DimDescrReady
		xor		ecx,		ecx
		mov		edx,		(AddEntryStr ptr [esi]).pDescr
		.WHILE	byte ptr [edx+ecx]!=0
			add		ecx,		1
		.ENDW
		mov		(AddEntryStr ptr [esi]).dimDescr,ecx
	DimDescrReady:
	
	cmp		(AddEntryStr ptr [esi]).dimCont, -1
	jne		DimContReady
		xor		ecx,		ecx
		mov		edx,		(AddEntryStr ptr [esi]).pCont
		.WHILE	byte ptr [edx+ecx]!=0
			add		ecx,		1
		.ENDW
		mov		(AddEntryStr ptr [esi]).dimCont,ecx
	DimContReady:
	
	;compute space needed by table
	mov		eax,		DBFMemory.NrOfEntrys
	shl		eax,		3
	mov		ebx,		eax
	add		eax,		8
	cmp		eax,		DBFMemory.dimTable
	jbe		@F
		;redim the table
		add		eax,			100h
		INVOKE	HeapReAlloc,	hHeap,0,DBFMemory.pTable,eax
		test	eax,			eax
		jz		Getout
		mov		DBFMemory.pTable, eax
		INVOKE	HeapSize,		hHeap,0,eax
		mov		DBFMemory.dimTable,eax
	@@:
	add		ebx,		DBFMemory.pTable
	;ebx now points to the place in table where new values should be inserted
	INVOKE	HeapAlloc,	hHeap,0,SIZEOF Entry
	mov		pEntry,		eax
	test	eax,		eax
	jz		Getout
	INVOKE	SetFilePointer,	DBFMemory.hFileDBF,0,0,FILE_END
	;store the offset in file
	mov		ecx,		SIZEOF Entry
	mov		dword ptr [ebx],	eax
	add		ecx,		(AddEntryStr ptr [esi]).dimName
	add		ecx,		(AddEntryStr ptr [esi]).dimDescr
	add		ecx,		(AddEntryStr ptr [esi]).dimCont
	;store the dimension
	mov		dword ptr [ebx+4],	ecx
	
	;store the values in our Entry structure
	mov		ebx,		pEntry
	mov		eax,		(AddEntryStr ptr [esi]).dimName
	mov		edx,		(AddEntryStr ptr [esi]).dimDescr
	mov		ecx,		(AddEntryStr ptr [esi]).dimCont
	mov		(Entry ptr [ebx]).LenName, eax
	mov		(Entry ptr [ebx]).LenDescription, edx
	mov		(Entry ptr [ebx]).LenCont, ecx
	mov		eax,		(AddEntryStr ptr [esi]).Time1
	mov		edx,		(AddEntryStr ptr [esi]).Time2
	mov		(Entry ptr [ebx]).TimeToRunIntel, eax
	mov		(Entry ptr [ebx]).TimeToRunAMD,edx
	;write the entry
	INVOKE	WriteFile,	DBFMemory.hFileDBF,pEntry,SIZEOF Entry,ADDR Answer,NULL
	INVOKE	WriteFile,	DBFMemory.hFileDBF,(AddEntryStr ptr [esi]).pName,(AddEntryStr ptr [esi]).dimName,ADDR Answer,NULL
	INVOKE	WriteFile,	DBFMemory.hFileDBF,(AddEntryStr ptr [esi]).pDescr,(AddEntryStr ptr [esi]).dimDescr,ADDR Answer,NULL
	INVOKE	WriteFile,	DBFMemory.hFileDBF,(AddEntryStr ptr [esi]).pCont,(AddEntryStr ptr [esi]).dimCont,ADDR Answer,NULL
	
	;QUESTION!!!
	;Would it be faster to allocate a larger bloc of memory,
	;copy all the text in it along with Entry structure and write 
	;just once???
	
	
	
Getout:
cmp		pEntry,		0
je		@F
	INVOKE	HeapFree,	hHeap,0,pEntry
@@:
mov		eax,		Error
ret
AddDBFEntry			ENDP
;--------------------------------------------------------------------------------
RemDBFEntry			PROC	uses ebx EntryIndex:DWORD
;we need only to remove the entry from the table
;because, when program is about to terminate,
;the DB file will be compacted, and only referenced
;structures will be keeped
	
	mov		edx,		EntryIndex
	mov		ebx,		DBFMemory.pTable
	xor		ecx,		ecx
	.WHILE	edx<DBFMemory.NrOfEntrys
		cmp		edx,		dword ptr [ebx+ecx*8]
		je		IndexFound
		add		ecx,		1
	.ENDW
	jmp		GetOut
	
	IndexFound:
	.WHILE	ecx<DBFMemory.NrOfEntrys
		mov		eax, dword ptr [ebx+ecx*8+ 8]
		mov		edx, dword ptr [ebx+ecx*8+12]
		mov		dword ptr [ebx+ecx*8],eax
		mov		dword ptr [ebx+ecx*8+4],edx
		add		ecx,		1
	.ENDW
	sub		DBFMemory.NrOfEntrys, 1
	
GetOut:
ret
RemDBFEntry 		ENDP
;--------------------------------------------------------------------------------
ReadDBFEntry		PROC	EntryIndex:DWORD
LOCAL	pEntry		:DWORD
LOCAL	Error		:DWORD
LOCAL	Answer		:DWORD


	mov		Error,		0
	mov		pEntry,		0
	
	mov		edx,		EntryIndex
	mov		eax,		DBFMemory.pTable
	xor		ecx,		ecx
	.WHILE	edx<DBFMemory.NrOfEntrys
		cmp		edx,		dword ptr [eax+ecx*8]
		je		IndexFound
		add		ecx,		1
	.ENDW
	jmp		GetOut
	IndexFound:
	shl		ecx,		3
	
	add		eax,		ecx
	push	dword ptr [eax+4]
	push	dword ptr FILE_BEGIN
	push	NULL
	push	dword ptr [eax]
	INVOKE	HeapAlloc,	hHeap,0,dword ptr [eax+4]
	test	eax,		eax
	jnz		@F
		add		esp,		12
		jmp		GetOut
	@@:
	mov		pEntry,		eax
	push	DBFMemory.hFileDBF
	call	SetFilePointer
	pop		ecx
	INVOKE	ReadFile,	DBFMemory.hFileDBF,pEntry,ecx,ADDR Answer,NULL
	
	;entire structure is now in memory

	mov		Error,		1
GetOut:
cmp		pEntry,		0
je		@F
	INVOKE	HeapFree,	hHeap,0,pEntry
@@:
mov		eax,		Error
ret
ReadDBFEntry		ENDP
;--------------------------------------------------------------------------------




